<?php

namespace EventPortal\Http\Controllers\Delegate\Event;

use EventPortal\Contracts\Event;
use EventPortal\Domain\Event\CallToAction;
use EventPortal\Domain\Event\ValueObjects\EventDetails;
use EventPortal\Domain\Event\ValueObjects\PageHeader;
use EventPortal\Domain\Util\DelegateRender;
use EventPortal\Http\Controllers\Controller;
use Inertia\Response;

class LandingController extends Controller
{
    public function __invoke(Event $event): Response
    {
        $callToAction = CallToAction::make()->forEventAndDelegate($event, auth()->user()->delegate);

        return DelegateRender::component('Delegate/Landing/Index')
            ->withPageHeader(
                PageHeader::make()
                    ->title($event->name)
                    ->description($event->snippet)
                    ->callToAction($callToAction->asWhite()->get())
                    ->heroImage(null)
            )
            ->withEventDetails(EventDetails::make($event, $callToAction->notWhite()->getAsArray()))
            ->withSpeakers($event->speakers)
            ->withVenues($event->venues)
            ->get();
    }
}
